/*###############################################################################
# Linux Management Providers (LMP), Sensors provider package
# Copyright (C) 2009 Shakhrom RUSTAMOV <shahrombek@gmail.com>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by 2009 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr>
###############################################################################*/

#ifndef OPENDRIM_COMPUTERSYSTEMSENSORACCESS_H_
#define OPENDRIM_COMPUTERSYSTEMSENSORACCESS_H_

#include "Sensors_Common.h"

#include "OpenDRIM_ComputerSystemSensor.h"
#include "assocOpenDRIM_ComputerSystemSensor.h"

int Sensors_OpenDRIM_ComputerSystemSensor_load(const CMPIBroker* broker, string& errorMessage);

int Sensors_OpenDRIM_ComputerSystemSensor_unload(string& errorMessage);

int Sensors_OpenDRIM_ComputerSystemSensor_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_ComputerSystemSensor>& instances, const char** properties, string& errorMessage, const string& discriminant);

int Sensors_OpenDRIM_ComputerSystemSensor_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_ComputerSystemSensor& instance, const char** properties, string& errorMessage);

int Sensors_OpenDRIM_ComputerSystemSensor_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_ComputerSystemSensor& newInstance, const OpenDRIM_ComputerSystemSensor& oldInstance, const char** properties, string& errorMessage);

int Sensors_OpenDRIM_ComputerSystemSensor_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_ComputerSystemSensor& instance, string& errorMessage);

int Sensors_OpenDRIM_ComputerSystemSensor_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_ComputerSystemSensor& instance, string& errorMessage);

int Sensors_OpenDRIM_ComputerSystemSensor_associatorPartComponentToGroupComponent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& PartComponent_instance, const char** properties, vector<Instance>& GroupComponent_associatedInstances, string& errorMessage, const string& discriminant);

int Sensors_OpenDRIM_ComputerSystemSensor_associatorGroupComponentToPartComponent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& GroupComponent_instance, const char** properties, vector<Instance>& PartComponent_associatedInstances, string& errorMessage, const string& discriminant);

int Sensors_OpenDRIM_ComputerSystemSensor_referencePartComponentToGroupComponent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& PartComponent_instance, const vector<Instance>& GroupComponent_instances, vector<OpenDRIM_ComputerSystemSensor>& OpenDRIM_ComputerSystemSensor_instances, const char** properties, string& errorMessage, const string& discriminant);

int Sensors_OpenDRIM_ComputerSystemSensor_referenceGroupComponentToPartComponent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& GroupComponent_instance, const vector<Instance>& PartComponent_instances, vector<OpenDRIM_ComputerSystemSensor>& OpenDRIM_ComputerSystemSensor_instances, const char** properties, string& errorMessage, const string& discriminant);

int Sensors_OpenDRIM_ComputerSystemSensor_populate(OpenDRIM_ComputerSystemSensor& instance, string& errorMessage);

#endif /*OPENDRIM_COMPUTERSYSTEMSENSORACCESS_H_*/
