/*###############################################################################
# Linux Management Providers (LMP), Sensors provider package
# Copyright (C) 2009 Shakhrom RUSTAMOV <shahrombek@gmail.com>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by 2009 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr>
###############################################################################*/

#ifndef OPENDRIM_NUMERICSENSORACCESS_H_
#define OPENDRIM_NUMERICSENSORACCESS_H_

#include "Sensors_Common.h"

#include "OpenDRIM_NumericSensor.h"

int Sensors_OpenDRIM_NumericSensor_load(const CMPIBroker* broker, string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_unload(string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_NumericSensor>& instances, const char** properties, string& errorMessage, const string& discriminant);

int Sensors_OpenDRIM_NumericSensor_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_NumericSensor& instance, const char** properties, string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_NumericSensor& newInstance, const OpenDRIM_NumericSensor& oldInstance, const char** properties, string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_NumericSensor& instance, string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_NumericSensor& instance, string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_RequestStateChange(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_NumericSensor& instance, unsigned int& returnValue, const OpenDRIM_NumericSensor_RequestStateChange_In& in, OpenDRIM_NumericSensor_RequestStateChange_Out& out, string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_SetPowerState(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_NumericSensor& instance, unsigned int& returnValue, const OpenDRIM_NumericSensor_SetPowerState_In& in, string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_Reset(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_NumericSensor& instance, unsigned int& returnValue, string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_EnableDevice(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_NumericSensor& instance, unsigned int& returnValue, const OpenDRIM_NumericSensor_EnableDevice_In& in, string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_OnlineDevice(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_NumericSensor& instance, unsigned int& returnValue, const OpenDRIM_NumericSensor_OnlineDevice_In& in, string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_QuiesceDevice(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_NumericSensor& instance, unsigned int& returnValue, const OpenDRIM_NumericSensor_QuiesceDevice_In& in, string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_SaveProperties(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_NumericSensor& instance, unsigned int& returnValue, string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_RestoreProperties(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_NumericSensor& instance, unsigned int& returnValue, string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_RestoreDefaultThresholds(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_NumericSensor& instance, unsigned int& returnValue, string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_GetNonLinearFactors(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_NumericSensor& instance, unsigned int& returnValue, const OpenDRIM_NumericSensor_GetNonLinearFactors_In& in, OpenDRIM_NumericSensor_GetNonLinearFactors_Out& out, string& errorMessage);

int Sensors_OpenDRIM_NumericSensor_populate(OpenDRIM_NumericSensor& instance, string& errorMessage);

#endif /*OPENDRIM_NUMERICSENSORACCESS_H_*/
