#!/bin/bash

################################################################################
# Linux Management Providers (LMP), Sensors provider package
# Copyright (C) 2009 Shakhrom RUSTAMOV <shahrombek@gmail.com>
# 
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
# 
# Modified by 2009 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr>
################################################################################

if test "$3" = pegasus
then
	
	cimmof -aE -n $1 $6/mof/OpenDRIM_EnabledSensorCapabilities.mof

	OUTFILE=./TEMP_REGISTRATION
	
cat >> $OUTFILE << EOFC
instance of PG_ProviderModule {
Caption = "OpenDRIM_EnabledSensorCapabilities provider module";
Name = "Sensors_OpenDRIM_EnabledSensorCapabilitiesModule";
Location = "cmpiSensors_OpenDRIM_EnabledSensorCapabilitiesProvider";
Vendor = "$2";
Version = "$5";
InterfaceType = "CMPI";
InterfaceVersion = "2.0.0";
};

instance of PG_Provider {
Caption = "OpenDRIM_EnabledSensorCapabilities provider";
Name = "Sensors_OpenDRIM_EnabledSensorCapabilitiesProvider";
ProviderModuleName = "Sensors_OpenDRIM_EnabledSensorCapabilitiesModule";
};

instance of PG_ProviderCapabilities {
Caption = "OpenDRIM_EnabledSensorCapabilities provider capabilities";
ProviderModuleName = "Sensors_OpenDRIM_EnabledSensorCapabilitiesModule";
ProviderName = "Sensors_OpenDRIM_EnabledSensorCapabilitiesProvider";
ClassName = "OpenDRIM_EnabledSensorCapabilities";
ProviderType = {2};
Namespaces = {"$1"};
SupportedProperties = {"Caption", "Description", "InstanceID", "ElementName", "ElementNameEditSupported", "MaxElementNameLen", "RequestedStatesSupported", "ElementNameMask"};
CapabilityID = "Sensors_OpenDRIM_EnabledSensorCapabilities";
};

EOFC
	
	cimmof -n root/PG_InterOp $OUTFILE
	
	rm -f $OUTFILE
	
fi

if test "$3" = sfcb
then
	
	OUTFILE=./OpenDRIM_EnabledSensorCapabilities.reg
	
cat >> $OUTFILE <<EOFC
[OpenDRIM_EnabledSensorCapabilities]   
   provider: Sensors_OpenDRIM_EnabledSensorCapabilitiesProvider
   location: cmpiSensors_OpenDRIM_EnabledSensorCapabilitiesProvider
   type: instance
   namespace: $1
#
EOFC
	
	sfcbstage -r $OUTFILE -n $1 $6/mof/OpenDRIM_EnabledSensorCapabilities.mof
	
	rm -f $OUTFILE
	
	sfcbrepos -f
	
fi

if test "$3" = openwbem
then
	
	OUTFILE=./OpenDRIM_EnabledSensorCapabilities-reg.mof
	rm -f $OUTFILE
	sed "s/Provider *( *\"cmpi:/Provider(\"cmpi::/g" < $6/mof/OpenDRIM_EnabledSensorCapabilities.mof >> $OUTFILE
	owmofc -u http://localhost/$1 $OUTFILE
	
	rm -f $OUTFILE
	
fi
